package it.sw.pa.comune.artegna.web.rest;

import static it.sw.pa.comune.artegna.domain.DisponibilitaAsserts.*;
import static it.sw.pa.comune.artegna.web.rest.TestUtil.createUpdateProxyForBean;
import static org.assertj.core.api.Assertions.assertThat;
import static org.hamcrest.Matchers.hasItem;
import static org.mockito.Mockito.*;
import static org.springframework.security.test.web.servlet.request.SecurityMockMvcRequestPostProcessors.csrf;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.*;

import com.fasterxml.jackson.databind.ObjectMapper;
import it.sw.pa.comune.artegna.IntegrationTest;
import it.sw.pa.comune.artegna.domain.Disponibilita;
import it.sw.pa.comune.artegna.domain.enumeration.GiornoSettimana;
import it.sw.pa.comune.artegna.domain.enumeration.TipoDisponibilita;
import it.sw.pa.comune.artegna.repository.DisponibilitaRepository;
import it.sw.pa.comune.artegna.service.DisponibilitaService;
import it.sw.pa.comune.artegna.service.dto.DisponibilitaDTO;
import it.sw.pa.comune.artegna.service.mapper.DisponibilitaMapper;
import jakarta.persistence.EntityManager;
import java.time.Instant;
import java.time.LocalDate;
import java.time.ZoneId;
import java.time.temporal.ChronoUnit;
import java.util.ArrayList;
import java.util.Random;
import java.util.concurrent.atomic.AtomicLong;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.http.MediaType;
import org.springframework.security.test.context.support.WithMockUser;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.transaction.annotation.Transactional;

/**
 * Integration tests for the {@link DisponibilitaResource} REST controller.
 */
@IntegrationTest
@ExtendWith(MockitoExtension.class)
@AutoConfigureMockMvc
@WithMockUser
class DisponibilitaResourceIT {

    private static final GiornoSettimana DEFAULT_GIORNO_SETTIMANA = GiornoSettimana.LUNEDI;
    private static final GiornoSettimana UPDATED_GIORNO_SETTIMANA = GiornoSettimana.MARTEDI;

    private static final LocalDate DEFAULT_DATA_SPECIFICA = LocalDate.ofEpochDay(0L);
    private static final LocalDate UPDATED_DATA_SPECIFICA = LocalDate.now(ZoneId.systemDefault());

    private static final Instant DEFAULT_ORA_INIZIO = Instant.ofEpochMilli(0L);
    private static final Instant UPDATED_ORA_INIZIO = Instant.now().truncatedTo(ChronoUnit.MILLIS);

    private static final Instant DEFAULT_ORA_FINE = Instant.ofEpochMilli(0L);
    private static final Instant UPDATED_ORA_FINE = Instant.now().truncatedTo(ChronoUnit.MILLIS);

    private static final String DEFAULT_ORARIO_INIZIO = "AAAAAAAAAA";
    private static final String UPDATED_ORARIO_INIZIO = "BBBBBBBBBB";

    private static final String DEFAULT_ORARIO_FINE = "AAAAAAAAAA";
    private static final String UPDATED_ORARIO_FINE = "BBBBBBBBBB";

    private static final TipoDisponibilita DEFAULT_TIPO = TipoDisponibilita.DISPONIBILE;
    private static final TipoDisponibilita UPDATED_TIPO = TipoDisponibilita.CHIUSURA;

    private static final String DEFAULT_NOTE = "AAAAAAAAAA";
    private static final String UPDATED_NOTE = "BBBBBBBBBB";

    private static final String ENTITY_API_URL = "/api/disponibilitas";
    private static final String ENTITY_API_URL_ID = ENTITY_API_URL + "/{id}";

    private static Random random = new Random();
    private static AtomicLong longCount = new AtomicLong(random.nextInt() + (2L * Integer.MAX_VALUE));

    @Autowired
    private ObjectMapper om;

    @Autowired
    private DisponibilitaRepository disponibilitaRepository;

    @Mock
    private DisponibilitaRepository disponibilitaRepositoryMock;

    @Autowired
    private DisponibilitaMapper disponibilitaMapper;

    @Mock
    private DisponibilitaService disponibilitaServiceMock;

    @Autowired
    private EntityManager em;

    @Autowired
    private MockMvc restDisponibilitaMockMvc;

    private Disponibilita disponibilita;

    private Disponibilita insertedDisponibilita;

    /**
     * Create an entity for this test.
     *
     * This is a static method, as tests for other entities might also need it,
     * if they test an entity which requires the current entity.
     */
    public static Disponibilita createEntity() {
        return new Disponibilita()
            .giornoSettimana(DEFAULT_GIORNO_SETTIMANA)
            .dataSpecifica(DEFAULT_DATA_SPECIFICA)
            .oraInizio(DEFAULT_ORA_INIZIO)
            .oraFine(DEFAULT_ORA_FINE)
            .orarioInizio(DEFAULT_ORARIO_INIZIO)
            .orarioFine(DEFAULT_ORARIO_FINE)
            .tipo(DEFAULT_TIPO)
            .note(DEFAULT_NOTE);
    }

    /**
     * Create an updated entity for this test.
     *
     * This is a static method, as tests for other entities might also need it,
     * if they test an entity which requires the current entity.
     */
    public static Disponibilita createUpdatedEntity() {
        return new Disponibilita()
            .giornoSettimana(UPDATED_GIORNO_SETTIMANA)
            .dataSpecifica(UPDATED_DATA_SPECIFICA)
            .oraInizio(UPDATED_ORA_INIZIO)
            .oraFine(UPDATED_ORA_FINE)
            .orarioInizio(UPDATED_ORARIO_INIZIO)
            .orarioFine(UPDATED_ORARIO_FINE)
            .tipo(UPDATED_TIPO)
            .note(UPDATED_NOTE);
    }

    @BeforeEach
    void initTest() {
        disponibilita = createEntity();
    }

    @AfterEach
    void cleanup() {
        if (insertedDisponibilita != null) {
            disponibilitaRepository.delete(insertedDisponibilita);
            insertedDisponibilita = null;
        }
    }

    @Test
    @Transactional
    void createDisponibilita() throws Exception {
        long databaseSizeBeforeCreate = getRepositoryCount();
        // Create the Disponibilita
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(disponibilita);
        var returnedDisponibilitaDTO = om.readValue(
            restDisponibilitaMockMvc
                .perform(
                    post(ENTITY_API_URL)
                        .with(csrf())
                        .contentType(MediaType.APPLICATION_JSON)
                        .content(om.writeValueAsBytes(disponibilitaDTO))
                )
                .andExpect(status().isCreated())
                .andReturn()
                .getResponse()
                .getContentAsString(),
            DisponibilitaDTO.class
        );

        // Validate the Disponibilita in the database
        assertIncrementedRepositoryCount(databaseSizeBeforeCreate);
        var returnedDisponibilita = disponibilitaMapper.toEntity(returnedDisponibilitaDTO);
        assertDisponibilitaUpdatableFieldsEquals(returnedDisponibilita, getPersistedDisponibilita(returnedDisponibilita));

        insertedDisponibilita = returnedDisponibilita;
    }

    @Test
    @Transactional
    void createDisponibilitaWithExistingId() throws Exception {
        // Create the Disponibilita with an existing ID
        disponibilita.setId(1L);
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(disponibilita);

        long databaseSizeBeforeCreate = getRepositoryCount();

        // An entity with an existing ID cannot be created, so this API call must fail
        restDisponibilitaMockMvc
            .perform(
                post(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(disponibilitaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Disponibilita in the database
        assertSameRepositoryCount(databaseSizeBeforeCreate);
    }

    @Test
    @Transactional
    void getAllDisponibilitas() throws Exception {
        // Initialize the database
        insertedDisponibilita = disponibilitaRepository.saveAndFlush(disponibilita);

        // Get all the disponibilitaList
        restDisponibilitaMockMvc
            .perform(get(ENTITY_API_URL + "?sort=id,desc"))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.[*].id").value(hasItem(disponibilita.getId().intValue())))
            .andExpect(jsonPath("$.[*].giornoSettimana").value(hasItem(DEFAULT_GIORNO_SETTIMANA.toString())))
            .andExpect(jsonPath("$.[*].dataSpecifica").value(hasItem(DEFAULT_DATA_SPECIFICA.toString())))
            .andExpect(jsonPath("$.[*].oraInizio").value(hasItem(DEFAULT_ORA_INIZIO.toString())))
            .andExpect(jsonPath("$.[*].oraFine").value(hasItem(DEFAULT_ORA_FINE.toString())))
            .andExpect(jsonPath("$.[*].orarioInizio").value(hasItem(DEFAULT_ORARIO_INIZIO)))
            .andExpect(jsonPath("$.[*].orarioFine").value(hasItem(DEFAULT_ORARIO_FINE)))
            .andExpect(jsonPath("$.[*].tipo").value(hasItem(DEFAULT_TIPO.toString())))
            .andExpect(jsonPath("$.[*].note").value(hasItem(DEFAULT_NOTE)));
    }

    @SuppressWarnings({ "unchecked" })
    void getAllDisponibilitasWithEagerRelationshipsIsEnabled() throws Exception {
        when(disponibilitaServiceMock.findAllWithEagerRelationships(any())).thenReturn(new PageImpl(new ArrayList<>()));

        restDisponibilitaMockMvc.perform(get(ENTITY_API_URL + "?eagerload=true")).andExpect(status().isOk());

        verify(disponibilitaServiceMock, times(1)).findAllWithEagerRelationships(any());
    }

    @SuppressWarnings({ "unchecked" })
    void getAllDisponibilitasWithEagerRelationshipsIsNotEnabled() throws Exception {
        when(disponibilitaServiceMock.findAllWithEagerRelationships(any())).thenReturn(new PageImpl(new ArrayList<>()));

        restDisponibilitaMockMvc.perform(get(ENTITY_API_URL + "?eagerload=false")).andExpect(status().isOk());
        verify(disponibilitaRepositoryMock, times(1)).findAll(any(Pageable.class));
    }

    @Test
    @Transactional
    void getDisponibilita() throws Exception {
        // Initialize the database
        insertedDisponibilita = disponibilitaRepository.saveAndFlush(disponibilita);

        // Get the disponibilita
        restDisponibilitaMockMvc
            .perform(get(ENTITY_API_URL_ID, disponibilita.getId()))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.id").value(disponibilita.getId().intValue()))
            .andExpect(jsonPath("$.giornoSettimana").value(DEFAULT_GIORNO_SETTIMANA.toString()))
            .andExpect(jsonPath("$.dataSpecifica").value(DEFAULT_DATA_SPECIFICA.toString()))
            .andExpect(jsonPath("$.oraInizio").value(DEFAULT_ORA_INIZIO.toString()))
            .andExpect(jsonPath("$.oraFine").value(DEFAULT_ORA_FINE.toString()))
            .andExpect(jsonPath("$.orarioInizio").value(DEFAULT_ORARIO_INIZIO))
            .andExpect(jsonPath("$.orarioFine").value(DEFAULT_ORARIO_FINE))
            .andExpect(jsonPath("$.tipo").value(DEFAULT_TIPO.toString()))
            .andExpect(jsonPath("$.note").value(DEFAULT_NOTE));
    }

    @Test
    @Transactional
    void getNonExistingDisponibilita() throws Exception {
        // Get the disponibilita
        restDisponibilitaMockMvc.perform(get(ENTITY_API_URL_ID, Long.MAX_VALUE)).andExpect(status().isNotFound());
    }

    @Test
    @Transactional
    void putExistingDisponibilita() throws Exception {
        // Initialize the database
        insertedDisponibilita = disponibilitaRepository.saveAndFlush(disponibilita);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the disponibilita
        Disponibilita updatedDisponibilita = disponibilitaRepository.findById(disponibilita.getId()).orElseThrow();
        // Disconnect from session so that the updates on updatedDisponibilita are not directly saved in db
        em.detach(updatedDisponibilita);
        updatedDisponibilita
            .giornoSettimana(UPDATED_GIORNO_SETTIMANA)
            .dataSpecifica(UPDATED_DATA_SPECIFICA)
            .oraInizio(UPDATED_ORA_INIZIO)
            .oraFine(UPDATED_ORA_FINE)
            .orarioInizio(UPDATED_ORARIO_INIZIO)
            .orarioFine(UPDATED_ORARIO_FINE)
            .tipo(UPDATED_TIPO)
            .note(UPDATED_NOTE);
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(updatedDisponibilita);

        restDisponibilitaMockMvc
            .perform(
                put(ENTITY_API_URL_ID, disponibilitaDTO.getId())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(disponibilitaDTO))
            )
            .andExpect(status().isOk());

        // Validate the Disponibilita in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertPersistedDisponibilitaToMatchAllProperties(updatedDisponibilita);
    }

    @Test
    @Transactional
    void putNonExistingDisponibilita() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        disponibilita.setId(longCount.incrementAndGet());

        // Create the Disponibilita
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(disponibilita);

        // If the entity doesn't have an ID, it will throw BadRequestAlertException
        restDisponibilitaMockMvc
            .perform(
                put(ENTITY_API_URL_ID, disponibilitaDTO.getId())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(disponibilitaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Disponibilita in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void putWithIdMismatchDisponibilita() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        disponibilita.setId(longCount.incrementAndGet());

        // Create the Disponibilita
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(disponibilita);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restDisponibilitaMockMvc
            .perform(
                put(ENTITY_API_URL_ID, longCount.incrementAndGet())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(disponibilitaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Disponibilita in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void putWithMissingIdPathParamDisponibilita() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        disponibilita.setId(longCount.incrementAndGet());

        // Create the Disponibilita
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(disponibilita);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restDisponibilitaMockMvc
            .perform(
                put(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(disponibilitaDTO))
            )
            .andExpect(status().isMethodNotAllowed());

        // Validate the Disponibilita in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void partialUpdateDisponibilitaWithPatch() throws Exception {
        // Initialize the database
        insertedDisponibilita = disponibilitaRepository.saveAndFlush(disponibilita);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the disponibilita using partial update
        Disponibilita partialUpdatedDisponibilita = new Disponibilita();
        partialUpdatedDisponibilita.setId(disponibilita.getId());

        partialUpdatedDisponibilita
            .dataSpecifica(UPDATED_DATA_SPECIFICA)
            .oraFine(UPDATED_ORA_FINE)
            .orarioInizio(UPDATED_ORARIO_INIZIO)
            .orarioFine(UPDATED_ORARIO_FINE)
            .tipo(UPDATED_TIPO);

        restDisponibilitaMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, partialUpdatedDisponibilita.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(partialUpdatedDisponibilita))
            )
            .andExpect(status().isOk());

        // Validate the Disponibilita in the database

        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertDisponibilitaUpdatableFieldsEquals(
            createUpdateProxyForBean(partialUpdatedDisponibilita, disponibilita),
            getPersistedDisponibilita(disponibilita)
        );
    }

    @Test
    @Transactional
    void fullUpdateDisponibilitaWithPatch() throws Exception {
        // Initialize the database
        insertedDisponibilita = disponibilitaRepository.saveAndFlush(disponibilita);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the disponibilita using partial update
        Disponibilita partialUpdatedDisponibilita = new Disponibilita();
        partialUpdatedDisponibilita.setId(disponibilita.getId());

        partialUpdatedDisponibilita
            .giornoSettimana(UPDATED_GIORNO_SETTIMANA)
            .dataSpecifica(UPDATED_DATA_SPECIFICA)
            .oraInizio(UPDATED_ORA_INIZIO)
            .oraFine(UPDATED_ORA_FINE)
            .orarioInizio(UPDATED_ORARIO_INIZIO)
            .orarioFine(UPDATED_ORARIO_FINE)
            .tipo(UPDATED_TIPO)
            .note(UPDATED_NOTE);

        restDisponibilitaMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, partialUpdatedDisponibilita.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(partialUpdatedDisponibilita))
            )
            .andExpect(status().isOk());

        // Validate the Disponibilita in the database

        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertDisponibilitaUpdatableFieldsEquals(partialUpdatedDisponibilita, getPersistedDisponibilita(partialUpdatedDisponibilita));
    }

    @Test
    @Transactional
    void patchNonExistingDisponibilita() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        disponibilita.setId(longCount.incrementAndGet());

        // Create the Disponibilita
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(disponibilita);

        // If the entity doesn't have an ID, it will throw BadRequestAlertException
        restDisponibilitaMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, disponibilitaDTO.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(disponibilitaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Disponibilita in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void patchWithIdMismatchDisponibilita() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        disponibilita.setId(longCount.incrementAndGet());

        // Create the Disponibilita
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(disponibilita);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restDisponibilitaMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, longCount.incrementAndGet())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(disponibilitaDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Disponibilita in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void patchWithMissingIdPathParamDisponibilita() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        disponibilita.setId(longCount.incrementAndGet());

        // Create the Disponibilita
        DisponibilitaDTO disponibilitaDTO = disponibilitaMapper.toDto(disponibilita);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restDisponibilitaMockMvc
            .perform(
                patch(ENTITY_API_URL)
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(disponibilitaDTO))
            )
            .andExpect(status().isMethodNotAllowed());

        // Validate the Disponibilita in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void deleteDisponibilita() throws Exception {
        // Initialize the database
        insertedDisponibilita = disponibilitaRepository.saveAndFlush(disponibilita);

        long databaseSizeBeforeDelete = getRepositoryCount();

        // Delete the disponibilita
        restDisponibilitaMockMvc
            .perform(delete(ENTITY_API_URL_ID, disponibilita.getId()).with(csrf()).accept(MediaType.APPLICATION_JSON))
            .andExpect(status().isNoContent());

        // Validate the database contains one less item
        assertDecrementedRepositoryCount(databaseSizeBeforeDelete);
    }

    protected long getRepositoryCount() {
        return disponibilitaRepository.count();
    }

    protected void assertIncrementedRepositoryCount(long countBefore) {
        assertThat(countBefore + 1).isEqualTo(getRepositoryCount());
    }

    protected void assertDecrementedRepositoryCount(long countBefore) {
        assertThat(countBefore - 1).isEqualTo(getRepositoryCount());
    }

    protected void assertSameRepositoryCount(long countBefore) {
        assertThat(countBefore).isEqualTo(getRepositoryCount());
    }

    protected Disponibilita getPersistedDisponibilita(Disponibilita disponibilita) {
        return disponibilitaRepository.findById(disponibilita.getId()).orElseThrow();
    }

    protected void assertPersistedDisponibilitaToMatchAllProperties(Disponibilita expectedDisponibilita) {
        assertDisponibilitaAllPropertiesEquals(expectedDisponibilita, getPersistedDisponibilita(expectedDisponibilita));
    }

    protected void assertPersistedDisponibilitaToMatchUpdatableProperties(Disponibilita expectedDisponibilita) {
        assertDisponibilitaAllUpdatablePropertiesEquals(expectedDisponibilita, getPersistedDisponibilita(expectedDisponibilita));
    }
}
